import scrapy
import datetime as dt
from creatures.items import Creature
from typing import List
from scrapy.loader import ItemLoader


class CreateListSpider(scrapy.Spider):
    name = "creatures"
    start_urls = ["https://pf2.d20pfsrd.com/monster"]

    def parse(self, response):
        # from scrapy.shell import inspect_response
        # inspect_response(response, self)
        rows = response.xpath('//table[@id="archive-data-table"]'
                              '/tr')
        for row in rows:
            loader = ItemLoader(item=Creature(), selector=row)
            loader.add_xpath('name', './td[1]/a/text()')
            loader.add_xpath('family', './td[2]/a/text()')
            loader.add_xpath('level', './td[3]/a/text()')
            loader.add_xpath('publisher', './td[4]/a/text()')
            loader.add_xpath('source', './td[5]/a/text()')
            loader.add_xpath('url', './td[1]/a/@href')
            yield loader.load_item()
